/* ================================ tutor1.h ================================ */
/* Declarations and Definitions for tutor1.c                                  */
/* ========================================================================== */

/* ------------------------- Duplication Prevention ------------------------- */

#if !defined(TUTOR1h) /* If tutor1.h has not already been processed,      */
#define TUTOR1h       /* define "already processed" flag, then go ahead   */

/* --------------------------- Required Headers ----------------------------- */
#include <stdio.h>
#include "tutor2.h"
#include "tutor3.h"

/* --------------------------- Global Constants ----------------------------- */
#define WORDSZ 17 /* word length + 1 */

/* ---------------------------- Global Macros ------------------------------- */

                                /*--DECODE--*/
/* Simulate a 2-to-4 decoder.                                                      */
/*   code:   char array representing a 2-bit BCD signal to be decoded.              */
/*   result: char array representing 4 bits, having a bit pattern of              */
/*               exactly 1 high bit; the position position of the high bit      */
/*               is determined by the input code:                               */
/*               00=1000, 01=0100, 10=0010, 11=0001.                              */
#define DECODE(code,result){\
          result[0]=AND(INV(code[0]),INV(code[1]));\
          result[1]=AND(INV(code[0]),code[1]);\
          result[2]=AND(code[0],INV(code[1]));\
          result[3]=AND(code[0],code[1]);\
          }

/* -------------------------- Function Prototypes --------------------------- */
extern void showres(char func[],char result[],char sign,char oflo);
extern void getfunc(char f[],short *nbits);
extern void getops(char func[],char a[],char b[],short *nrbits);
extern void getwd(char a[],short limit,short *nchar);

#endif /* If tutor1.h has not already been processed */
/* ========================================================================== */

00032570
